 /*
 * Project: Device in Jar. Greenhouse.
 * Device:  Main Atmega32
 * File:    Common constants for the project (Atmega32, MPU)
 *
 * License: freeware. Impressed by other cool ideas, will be happy if I inspire to new ideas.
 *
 * © 2010 by Maxim Ushakov; www.maxamuxa.com; head@maxamuxa.com
 */
#ifndef __MPU_SETTINGS_H__
#define __MPU_SETTINGS_H__

//speed of the MPU for all applications
#define F_CPU 16000000UL

//This project is meant to run on 16MHz Atmega32 only.
//I do not care if the same code could run on other Atmega & frequencies
//(it should, I believe), but this rule eases my life.
#if F_CPU != 16000000UL
#error 'Only 16MHz MPU is allowed for this project'
#endif
#ifndef __AVR_ATmega32__
#error 'Only Atmega32 MPU is allowed for this project'
#endif

#endif //__MPU_SETTINGS_H__