 /*
 * Project: Device in Jar. Greenhouse.
 * Device:  Main Atmega32
 * File:    One of the bases of the idea. Events are sent between everything and build almost all the activyty
 *          of the system.
 *
 * License: freeware. Impressed by other cool ideas, will be happy if I inspire to new ideas.
 *
 * © 2010 by Maxim Ushakov; www.maxamuxa.com; head@maxamuxa.com
 */
#ifndef __EVENTS_H__
#define __EVENTS_H__

//All events known in the system
enum Events
{
 //system time for some purposes
 event_SystemTime_second,
 event_SystemTime_40ms,

 //some data storage is changed
 event_ClockData_changed,
 event_ButtonsData_changed,
 event_TemperatureData_changed,
 event_ClimateData_changed,
 event_StateData_changed,
 event_HeapData_changed,

 //clock
 event_ClockSubsystem_minuteElapsed,
 event_ClockSubsystem_hourElapsed,

 //buttons could send numerous events
 event_ButtonsSubsystem_userComes,
 event_ButtonsSubsystem_userLeaves,
 
 event_ButtonsSubsystem_lightLamps,
 event_ButtonsSubsystem_putOutLamps,
 
 event_ButtonsSubsystem_watering,
 
 event_ButtonsSubsystem_shiftUp,
 event_ButtonsSubsystem_shiftDown,
 
 event_ButtonsSubsystem_startInput,
 event_ButtonsSubsystem_stopInput,
 
 event_ButtonsSubsystem_switchMode,
 
 event_ButtonsSubsystem_inputUp,
 event_ButtonsSubsystem_inputDown,
 event_ButtonsSubsystem_inputRepeatedUp,
 event_ButtonsSubsystem_inputRepeatedDown,
 
 event_ButtonsSubsystem_button0Pressed,
 event_ButtonsSubsystem_button1Pressed,
 event_ButtonsSubsystem_button2Pressed,
 event_ButtonsSubsystem_button3Pressed,
 event_ButtonsSubsystem_button4Pressed,
 event_ButtonsSubsystem_button0Released,
 event_ButtonsSubsystem_button1Released,
 event_ButtonsSubsystem_button2Released,
 event_ButtonsSubsystem_button3Released,
 event_ButtonsSubsystem_button4Released
};

//This function transmit all events to the subscribed subsystems.
//It reflects the real structure of interactions between subsystems.
void throwEvent( Events event );

#endif //__EVENTS_H__